uniform sampler2D image;
uniform bool texture_enabled;
uniform lowp float saturation;
uniform bool picking;
uniform bool use_alpha_picking;

varying mediump vec4 v_color;
varying highp vec2 v_uv;

void main()
{
    gl_FragColor = v_color;
    if (texture_enabled) {
        gl_FragColor *= texture2D(image, v_uv);
    }
    if (saturation != 1.0) {
        gl_FragColor.rgb = mix(vec3((gl_FragColor.r + gl_FragColor.g + gl_FragColor.b) * 0.333333 * 0.7), gl_FragColor.rgb, saturation);
    }
	if (picking) {
		if (gl_FragColor.a > 0.0 || !use_alpha_picking) {
			gl_FragColor = vec4(v_color.rgb, 1.0);
		} else {
			gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
		}
	}
}
