uniform sampler2D image;

varying highp vec2 v_uv;

void main()
{
    mediump vec4 center_rgba = texture2D(image, v_uv);
    mediump vec3 center = center_rgba.rgb;

    highp float pixel_w = 1.0/2048.0;
    highp float pixel_h = 1.0/2048.0;

    mediump vec3 left  = texture2D(image, v_uv + vec2(-pixel_w, 0.0)).rgb;
    mediump vec3 right = texture2D(image, v_uv + vec2( pixel_w, 0.0)).rgb;
    mediump vec3 down  = texture2D(image, v_uv + vec2(0.0, -pixel_h)).rgb;
    mediump vec3 up    = texture2D(image, v_uv + vec2(0.0,  pixel_h)).rgb;

    mediump vec3 color = -4.0 * center;
    color += 1.0 * left;
    color += 1.0 * right;
    color += 1.0 * down;
    color += 1.0 * up;

    color *= 2.5;
	
	//color += center;
	//color = mix(color, center, 0.4);

	mediump float edge = clamp(max(max(color.r, color.g), color.b), 0.0, 1.0);
	color = center*(1.0 - edge);
	
    gl_FragColor = vec4(color, center_rgba.a);
}
